﻿Public Class frmRemoteExplorer
    Private sRemoteUser As String
    Private nLaufwerke As New List(Of TreeNode)
    Public Overloads Sub Show(ByVal sRemoteUser As String)
        Me.sRemoteUser = sRemoteUser
        Me.Text &= " (" & sRemoteUser & ")"
        Dim s As New List(Of Object)
        s.Add("get laufwerke")
        frmMain.sendExplorerRequest(sRemoteUser, s)
        Me.Show()
    End Sub
    Public Sub dataArrived(ByRef oData As List(Of Object))
        Select Case oData(0).ToString
            Case "laufwerke"
                For Each sLaufwerk In CType(oData(1), List(Of String))
                    Dim n As New TreeNode(sLaufwerk)
                    trvExplorer.Nodes.Add(n)
                    nLaufwerke.Add(n)
                Next
            Case "folders"
                Dim sPfad As String = oData(1).ToString
                Dim tnd As TreeNode = getNodeVonPfad(sPfad)
                Dim iAnzahlUnterOrdner As Integer = 0
                For Each sOrdner In CType(oData(2), List(Of String))
                    tnd.Nodes.Add(sOrdner)
                    iAnzahlUnterOrdner += 1
                Next
                tnd.Expand()
                If iAnzahlUnterOrdner > 0 Then
                    trvExplorer.SelectedNode = tnd
                Else
                    If tnd.Parent IsNot Nothing Then
                        trvExplorer.SelectedNode = tnd.Parent
                    End If
                End If
        End Select
    End Sub
    Private Function getPfadVonNode(ByRef n As TreeNode) As String
        Dim sPfad As String = n.Text
        While n.Parent IsNot Nothing
            n = n.Parent
            sPfad = n.Text & sPfad
        End While
        Return sPfad
    End Function
    Private Function getKind(ByRef n As TreeNode, ByVal sText As String) As TreeNode
        Dim nFound As TreeNode = Nothing
        sText &= "\"
        For Each nKind As TreeNode In n.Nodes
            If nKind.Text = sText Then
                nFound = nKind
                Exit For
            End If
        Next
        Return nFound
    End Function
    Private Function getLaufwerksKnoten(ByVal sLaufwerk As String) As TreeNode
        Dim n As TreeNode = Nothing
        sLaufwerk &= "\"
        For Each nL In nLaufwerke
            If nL.Text = sLaufwerk Then
                n = nL
                Exit For
            End If
        Next
        Return n
    End Function
    Private Function getNodeVonPfad(ByVal sPfad As String) As TreeNode
        Dim n As TreeNode = Nothing
        Dim sOrdner() As String = Split(sPfad, "\")
        n = getLaufwerksKnoten(sOrdner(0))
        If UBound(sOrdner) > 0 Then
            Dim i As Integer = 1
            For i = 1 To UBound(sOrdner)
                If n IsNot Nothing Then
                    If sOrdner(i) <> "" Then
                        n = getKind(n, sOrdner(i))
                    End If
                End If
            Next
        End If
        Return n
    End Function
    Private Sub trvExplorer_AfterSelect(sender As Object, e As TreeViewEventArgs) Handles trvExplorer.AfterSelect
        If trvExplorer.SelectedNode IsNot Nothing Then
            If trvExplorer.SelectedNode.Nodes.Count = 0 Then
                Dim oReq As New List(Of Object)
                oReq.Add("get folders")
                oReq.Add(getPfadVonNode(trvExplorer.SelectedNode))
                frmMain.sendExplorerRequest(sRemoteUser, oReq)
            End If
        End If
    End Sub
End Class